mescc: Add another fopen test.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 94-unsetenv
142 95-signal
143 96-strto
144 97-fopen
145 98-fopen
146 "
147
148 # 90: needs GNU, fails for mescc, passes for tcc
149 broken="$broken
150 7s-struct-short
151 "
152
153 # gcc not supported
154 CC=
155 set +e
156 expect=$(echo $broken | wc -w)
157 pass=0
158 fail=0
159 total=0
160 for t in $tests; do
161     if [ -z "${t/[012][0-9]-*/}" ]; then
162         LIBC=c-mini
163         MESCCLIBS="-l c-mini"
164     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
165         LIBC=c+tcc
166         MESCCLIBS="-l c+tcc"
167     elif [ -z "${t/9[0-9]-*/}" ]; then
168         LIBC=c+gnu
169         MESCCLIBS="-l c+gnu"
170     else
171         LIBC=c
172         MESCCLIBS=
173     fi
174     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
175     r=$?
176     total=$((total+1))
177     if [ $r = 0 ]; then
178         echo $t: [OK]
179         pass=$((pass+1))
180     else
181         echo $t: [FAIL]
182         fail=$((fail+1))
183     fi
184 done
185
186 tests="
187 00_assignment
188 01_comment
189 02_printf
190 03_struct
191 04_for
192 05_array
193 06_case
194 07_function
195 08_while
196 09_do_while
197
198 10_pointer
199 11_precedence
200 12_hashdefine
201 13_integer_literals
202 14_if
203 15_recursion
204 16_nesting
205 17_enum
206 18_include
207 19_pointer_arithmetic
208
209 20_pointer_comparison
210 21_char_array
211 22_floating_point
212 23_type_coercion
213 24_math_library
214 25_quicksort
215 26_character_constants
216 27_sizeof
217 28_strings
218 29_array_address
219
220 30_hanoi
221 31_args
222 32_led
223 33_ternary_op
224 34_array_assignment
225 35_sizeof
226 36_array_initialisers
227 37_sprintf
228 38_multiple_array_index
229 39_typedef
230
231 40_stdio
232 41_hashif
233 42_function_pointer
234 43_void_param
235 44_scoped_declarations
236 45_empty_for
237 47_switch_return
238 48_nested_break
239 49_bracket_evaluation
240
241 50_logical_second_arg
242 51_static
243 52_unnamed_enum
244 54_goto
245 55_lshift_type
246 "
247
248 broken="$broken
249 18_include
250
251 22_floating_point
252 23_type_coercion
253 24_math_library
254 26_character_constants
255 27_sizeof
256 28_strings
257
258 34_array_assignment
259 39_typedef
260
261 40_stdio
262 42_function_pointer
263 49_bracket_evaluation
264 55_lshift_type
265 "
266
267 #22_floating_point       ; float
268 #23_type_coercion        ; float
269 #24_math_library         ; float
270 #27_sizeof               ; float
271 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
272 #30_hanoi                ; fails with GCC
273 #34_array_assignment     ; fails with GCC
274 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
275
276 #40_stdio                ; f* functions
277 #42_function_pointer     ; f* functions
278 #49_bracket_evaluation   ; float
279
280 LIBC=c+gnu
281 MESCCLIBS="-l c+gnu"
282
283 expect=$(echo $broken | wc -w)
284 ARGS="arg1 arg2 arg3 arg4 arg5"
285 export ARGS
286 for t in $tests; do
287     if [ ! -f scaffold/tinycc/"$t.c" ]; then
288         echo ' [SKIP]'
289         continue;
290     fi
291     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
292     r=$?
293     total=$((total+1))
294     if [ $r = 0 ]; then
295         echo $t: [OK]
296         pass=$((pass+1))
297     else
298         echo $t: [FAIL]
299         fail=$((fail+1))
300     fi
301 done
302 [ $expect != 0 ] && echo "expect: $expect"
303 [ $fail != 0 ] && echo "failed: $fail"
304 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
305 echo "passed: $pass"
306 echo "total:  $total"
307 if [ $fail != 0 -a $fail -gt $expect ]; then
308     echo FAILED: $fail/$total
309     exit 1
310 elif [ $fail != 0 ]; then
311     echo PASS: $pass/$total
312 else
313     echo PASS: $total
314 fi